"use strict";
/*

This file is generated from async/transactionalReadAsync.ts

*/
Object.defineProperty(exports, "__esModule", { value: true });
exports.transactionalRead = void 0;
const retry_1 = require("../retry");
/**
 * Similar to transactionalReadWrite and transactionalWrite but only allows reads.
 */
function transactionalRead(retries = 5) {
    return function (fn) {
        return function (dbOrTx, ...args) {
            if (!("transact" in dbOrTx))
                return fn(dbOrTx, ...args);
            return (0, retry_1.retry)(retries, () => {
                const tx = dbOrTx.transact();
                const result = fn(tx, ...args);
                tx.commit();
                return result;
            });
        };
    };
}
exports.transactionalRead = transactionalRead;
//# sourceMappingURL=../../../src/database/sync/transactionalRead.js.map